/// searches for files that intersect with the specified range.
#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash
)]
#[serde(crate = "conjure_object::serde")]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct TimeRangeFilter {
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::UtcTimestamp>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "start", skip_serializing_if = "Option::is_none", default)]
    start: Option<Box<super::UtcTimestamp>>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::UtcTimestamp>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "end", skip_serializing_if = "Option::is_none", default)]
    end: Option<Box<super::UtcTimestamp>>,
}
impl TimeRangeFilter {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new() -> Self {
        Self::builder().build()
    }
    #[inline]
    pub fn start(&self) -> Option<&super::UtcTimestamp> {
        self.start.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn end(&self) -> Option<&super::UtcTimestamp> {
        self.end.as_ref().map(|o| &**o)
    }
}
